-- DROP FUNCTION public.FN_RPT_TOTAL_PASIENKELAS (p_kelasCd Varchar(20), p_dateStart varchar,p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.FN_RPT_TOTAL_PASIENKELAS (p_kelasCd Varchar(20), p_dateStart varchar, p_dateEnd varchar)
-- RETURNS Bigint
-- AS
-- $$
--    	DECLARE v_intResult Int;
-- BEGIN
-- 	SELECT 
-- 	COUNT(A.medical_cd) into v_intResult
-- 	FROM trx_medical A, trx_ruang B
-- 	WHERE A.ruang_cd=B.ruang_cd
-- 	AND B.kelas_cd=p_kelasCd
-- 	AND (to_char(A.datetime_in, 'yyyy-mm-dd') BETWEEN p_dateStart AND p_dateEnd 
-- 	or to_char(A.datetime_out, 'yyyy-mm-dd') BETWEEN p_dateStart AND p_dateEnd);

-- 	RETURN v_intResult;
-- END;
-- $$ 
-- LANGUAGE plpgsql;

-- DROP FUNCTION public.FN_RPT_TOTAL_HARIRAWAT (p_kelasCd Varchar(10),p_dateStart varchar,p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.FN_RPT_TOTAL_HARIRAWAT (p_kelasCd Varchar(10),p_dateStart varchar,p_dateEnd varchar)
-- RETURNS Bigint
-- AS
-- $$
--    	DECLARE v_intResult Int;
-- BEGIN	
-- 		SELECT SUM(fn_datediff_day(to_char(A.datetime_in, 'yyyy-mm-dd'),to_char(A.datetime_out, 'yyyy-mm-dd')) + 1) into v_intResult
-- 		FROM trx_medical A, trx_ruang B
-- 		WHERE A.ruang_cd=B.ruang_cd
-- 		AND B.kelas_cd=p_kelasCd
-- 		AND (A.datetime_in BETWEEN p_dateStart::timestamp AND p_dateEnd::timestamp  OR
-- 		A.datetime_out BETWEEN p_dateStart::timestamp  AND p_dateEnd::timestamp);
		        		  				  
-- 	RETURN v_intResult;
-- END;
-- $$ LANGUAGE plpgsql;

-- DROP FUNCTION public.FN_INTERVAL_TO_INTEGER(p_interval interval);
--  CREATE OR REPLACE FUNCTION public.FN_INTERVAL_TO_INTEGER(p_interval interval)
--  RETURNS Int
--  as
--  $$
--  DECLARE v_intResult Int;
--  BEGIN
--  	SELECT coalesce(extract(epoch from p_interval), 0) into v_intResult;
--  	Return v_intResult;
--  END;
--  $$ 
--  LANGUAGE plpgsql;

-- DROP FUNCTION public.fn_last_day_month (p_date Varchar);
-- CREATE OR REPLACE FUNCTION public.fn_last_day_month (p_date Varchar)
-- RETURNS varchar
-- AS
-- $$
--    	DECLARE v_intResult varchar;
-- BEGIN	
-- 	SELECT (date_trunc('MONTH', p_date::timestamp) + INTERVAL '1 MONTH - 1 day')::DATE;    		  				  
-- 	RETURN v_intResult::varchar;
-- END;
-- $$ LANGUAGE plpgsql;

-- DROP FUNCTION public.FN_RPT_TOTAL_DEATH_OUTTP11 (p_KelasCd Varchar(10), p_dateStart varchar,p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.FN_RPT_TOTAL_DEATH_OUTTP11 (p_KelasCd Varchar(10), p_dateStart varchar,p_dateEnd varchar)
-- RETURNS Int
-- AS
-- $$
-- 	DECLARE v_intResult Int;
-- 	-- SELECT FN_INTERVAL_TO_INTEGER(SUM(a.datetime_out::timestamp - a.datetime_in::timestamp)) + 1 into v_intResult
-- BEGIN
-- 	SELECT FN_INTERVAL_TO_INTEGER(SUM(a.datetime_out::timestamp - a.datetime_in::timestamp)) into v_intResult
-- 	FROM trx_medical A, trx_ruang B
-- 	WHERE A.ruang_cd=B.ruang_cd
-- 	AND A.out_tp='OUT_TP_11'
-- 	AND B.kelas_cd=p_KelasCd
-- 	AND (A.datetime_in BETWEEN p_dateStart::timestamp AND p_dateEnd::timestamp  OR
-- 		A.datetime_out BETWEEN p_dateStart::timestamp  AND p_dateEnd::timestamp);   

-- 	RETURN v_intResult;
-- END;
-- $$ 
-- LANGUAGE plpgsql;


-- DROP FUNCTION public.FN_RPT_TOTAL_DEATH (p_KelasCd Varchar,p_DateStart varchar,p_DateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.FN_RPT_TOTAL_DEATH (p_KelasCd Varchar,p_DateStart varchar,p_DateEnd varchar)
-- RETURNS Int
-- AS
-- $$
-- 	DECLARE v_intResult Int;
-- BEGIN
-- 	SELECT 
-- 	SUM(fn_datediff_day(A.datetime_in::varchar,A.datetime_out::varchar) + 1) into v_intResult
-- 	FROM trx_medical A, trx_ruang B
-- 	WHERE A.ruang_cd=B.ruang_cd
-- 	AND A.out_tp IN ('OUT_TP_11','OUT_TP_12')
-- 	AND B.kelas_cd=p_KelasCd
-- 	AND (to_char(A.datetime_in,'yyyy-mm-dd') BETWEEN p_dateStart AND p_dateEnd OR
-- 		to_char(A.datetime_out,'yyyy-mm-dd') BETWEEN p_dateStart AND p_dateEnd);
	        		  				  
-- 	RETURN v_intResult;
-- END;
-- $$ LANGUAGE plpgsql;

-- DROP FUNCTION public.SP_RPT_GET_BOR(p_Month int,p_Year int);
-- CREATE OR REPLACE FUNCTION public.SP_RPT_GET_BOR(p_Month int,p_Year int) 
-- RETURNS table(
-- 	kelas_cd varchar,
-- 	kelas_nm varchar,
-- 	total_kamar Bigint,
-- 	total_pasien Bigint,
-- 	total_harirawat Bigint,
-- 	day_month integer
-- )
-- AS $$
-- 	DECLARE v_dtDateStart varchar;
--  	v_dtDateEnd varchar;
-- BEGIN
-- 	v_dtDateStart := concat(p_Year::Varchar, '-', LPAD(p_Month::varchar,2,'0')::Varchar, '-', '01')::varchar;
-- 	v_dtDateEnd := (date_trunc('MONTH', v_dtDateStart::timestamp) + INTERVAL '1 MONTH - 1 day')::DATE;

-- 	-- execute fn_last_day_month(v_dtDateStart) into v_dtDateEnd;
	
-- 	RETURN QUERY SELECT 
-- 	A.kelas_cd,
-- 	A.kelas_nm,
-- 	COUNT(B.ruang_cd) AS total_kamar,
-- 	COALESCE(public.FN_RPT_TOTAL_PASIENKELAS(A.kelas_cd,v_dtDateStart::varchar,v_dtDateEnd::varchar),0) AS total_pasien,
-- 	COALESCE(public.FN_RPT_TOTAL_HARIRAWAT(A.kelas_cd,v_dtDateStart,v_dtDateEnd),0) AS total_harirawat,
-- 	to_char(v_dtDateEnd::timestamp, 'dd')::integer AS day_month
-- 	FROM trx_kelas A 
-- 	JOIN trx_ruang B ON A.kelas_cd=B.kelas_cd AND COALESCE(B.ruang_tp,'')<>'1'
-- 	GROUP BY A.kelas_cd,A.kelas_nm
-- 	ORDER BY A.kelas_nm;
-- END;
-- $$ LANGUAGE plpgsql;

-- select * from public.SP_RPT_GET_BOR(2, 2017);

-- DROP FUNCTION public.SP_RPT_GET_NDR (p_Month int,p_Year int);
-- CREATE OR REPLACE FUNCTION public.SP_RPT_GET_NDR (p_Month int,p_Year int) 
-- RETURNS table(
-- 	kelas_cd varchar,
-- 	kelas_nm varchar,
-- 	total_kamar Bigint,
-- 	total_pasien Bigint,
-- 	total_meninggal int,
-- 	day_month integer
-- )
-- AS $$
-- 	DECLARE v_dtDateStart Timestamp(3);
-- 	v_dtDateEnd Timestamp(3);
-- BEGIN
-- 	v_dtDateStart := concat(p_Year::Varchar, '-', LPAD(p_Month::varchar,2,'0')::Varchar, '-', '01')::varchar;
-- 	v_dtDateEnd := (date_trunc('MONTH', v_dtDateStart::timestamp) + INTERVAL '1 MONTH - 1 day')::DATE;
-- 	-- execute fn_last_day_month(v_dtDateStart) into v_dtDateEnd;
-- 	RETURN QUERY SELECT 
-- 	A.kelas_cd,
-- 	A.kelas_nm,
-- 	COUNT(B.ruang_cd) AS total_kamar,
-- 	COALESCE(public.FN_RPT_TOTAL_PASIENKELAS(A.kelas_cd,v_dtDateStart::varchar,v_dtDateEnd::varchar),0) AS total_pasien,
-- 	COALESCE(public.FN_RPT_TOTAL_DEATH_OUTTP11(A.kelas_cd,v_dtDateStart::varchar,v_dtDateEnd::varchar),0) AS total_meninggal,
-- 	to_char(v_dtDateEnd::timestamp, 'dd')::integer AS day_month
-- 	FROM trx_kelas A 
-- 	JOIN trx_ruang B ON A.kelas_cd=B.kelas_cd AND COALESCE(B.ruang_tp,'')<>'1'
-- 	GROUP BY A.kelas_cd,A.kelas_nm
-- 	ORDER BY A.kelas_nm;
-- END;
-- $$ LANGUAGE plpgsql;

-- select * from public.SP_RPT_GET_NDR(2, 2017);

-- DROP FUNCTION public.SP_RPT_GET_GDR (p_Month int, p_Year int);
-- CREATE OR REPLACE FUNCTION public.SP_RPT_GET_GDR (p_Month int, p_Year int) 
-- RETURNS table(
-- 	kelas_cd varchar,
-- 	kelas_nm varchar,
-- 	total_kamar Bigint,
-- 	total_pasien Bigint,
-- 	total_meninggal int,
-- 	day_month integer
-- )
-- AS $$
-- 	DECLARE v_dtDateStart Timestamp(3);
-- 	v_dtDateEnd Timestamp(3);
-- BEGIN
-- 	v_dtDateStart := concat(p_Year::Varchar, '-', LPAD(p_Month::varchar,2,'0')::Varchar, '-', '01')::Timestamp;
-- 	v_dtDateEnd := (date_trunc('MONTH', v_dtDateStart::timestamp) + INTERVAL '1 MONTH - 1 day')::DATE;
	
-- 	RETURN QUERY SELECT 
-- 	A.kelas_cd,
-- 	A.kelas_nm,
-- 	COUNT(B.ruang_cd) AS total_kamar,
-- 	COALESCE(public.FN_RPT_TOTAL_PASIENKELAS(A.kelas_cd, v_dtDateStart::varchar,v_dtDateEnd::varchar),0) AS total_pasien,
-- 	COALESCE(public.FN_RPT_TOTAL_DEATH(A.kelas_cd,v_dtDateStart::varchar,v_dtDateEnd::varchar),0) AS total_meninggal,
-- 	to_char(v_dtDateEnd::timestamp, 'dd')::integer AS day_month
-- 	FROM trx_kelas A 
-- 	JOIN trx_ruang B ON A.kelas_cd=B.kelas_cd AND COALESCE(B.ruang_tp,'')<>'1'
-- 	GROUP BY A.kelas_cd,A.kelas_nm
-- 	ORDER BY A.kelas_nm;
-- END;
-- $$ 
-- LANGUAGE plpgsql;

-- select * from public.SP_RPT_GET_GDR(2, 2017);

-- DROP FUNCTION public.sp_rpt_rl_1_2_indikator_pelayanan_rumah_sakit(p_dateStart varchar, p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.sp_rpt_rl_1_2_indikator_pelayanan_rumah_sakit(p_dateStart varchar, p_dateEnd varchar)
--  RETURNS TABLE(kelas_cd character varying, kelas_nm character varying, total_kamar bigint, total_pasien bigint, total_harirawat bigint, total_meninggal int, day_month integer)
-- AS $function$
-- BEGIN
-- 	RETURN QUERY 
-- 	SELECT 
-- 	A.kelas_cd,
-- 	A.kelas_nm,
-- 	COUNT(B.ruang_cd) AS total_kamar,
-- 	coalesce(public.FN_RPT_TOTAL_PASIENKELAS(A.kelas_cd,p_dateStart,p_dateEnd), 0) AS total_pasien,
-- 	coalesce(public.FN_RPT_TOTAL_HARIRAWAT(A.kelas_cd,p_dateStart,p_dateEnd), 0) AS total_harirawat,
-- 	coalesce(public.FN_RPT_TOTAL_DEATH_OUTTP11(A.kelas_cd,p_dateStart::varchar,p_dateEnd::varchar), 0) AS total_meninggal,
-- 	to_char(p_dateEnd::timestamp, 'dd')::integer AS day_month
-- 	FROM trx_kelas A 
-- 	JOIN trx_ruang B ON A.kelas_cd=B.kelas_cd 
-- 	GROUP BY A.kelas_cd,A.kelas_nm
-- 	ORDER BY A.kelas_nm;
-- END;
-- $function$
--  LANGUAGE plpgsql;

-- SELECT * from public.sp_rpt_rl_1_2_indikator_pelayanan_rumah_sakit('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.sp_rpt_rl_1_3_fasilitas_tempat_tidur_rawat_inap(p_dateStart varchar, p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.sp_rpt_rl_1_3_fasilitas_tempat_tidur_rawat_inap(p_dateStart varchar, p_dateEnd varchar)
--  RETURNS TABLE(bangsal_cd character varying, bangsal_nm character varying, jumlah_tt bigint, vvip bigint, vip bigint, kelasi bigint, kelasii bigint, kelasiii bigint, kelaslain bigint)
-- AS $function$
-- BEGIN
-- 	-- SET NOCOUNT ON added to prevent extra result sets from
-- 	-- interfering with SELECT statements.
-- 	RETURN QUERY SELECT
-- 		trx_ruang.bangsal_cd,
-- 		trx_bangsal.bangsal_nm,
-- 		COUNT(1) AS jumlah_tt,
-- 		SUM(CASE WHEN trx_ruang.kelas_cd = 'KLVVIP' THEN 1 ELSE 0 END)AS vvip,
-- 		SUM(CASE WHEN trx_ruang.kelas_cd = 'KLVIP' THEN 1 ELSE 0 END)AS vip,
-- 		SUM(CASE WHEN trx_ruang.kelas_cd = 'KL01' THEN 1 ELSE 0 END)AS kelasI,
-- 		SUM(CASE WHEN trx_ruang.kelas_cd = 'KL02' THEN 1 ELSE 0 END)AS kelasII,
-- 		SUM(CASE WHEN trx_ruang.kelas_cd = 'KL03' THEN 1 ELSE 0 END)AS kelasIII,
-- 		SUM(CASE WHEN trx_ruang.kelas_cd NOT IN ('KLVVIP','KLVIP','KL01','KL02','KL03') THEN 1 ELSE 0 END) AS kelasLAIN
-- 	FROM trx_ruang
-- 	JOIN trx_bangsal ON trx_ruang.bangsal_cd = trx_bangsal.bangsal_cd
-- 	WHERE trx_ruang.modi_datetime >= p_dateStart::timestamp AND 
-- 	trx_ruang.modi_datetime <= p_dateEnd::timestamp
-- 	GROUP BY
-- 		trx_ruang.bangsal_cd,
-- 		trx_bangsal.bangsal_nm;
	
-- END;
-- $function$
-- LANGUAGE plpgsql;

-- SELECT * from public.sp_rpt_rl_1_3_fasilitas_tempat_tidur_rawat_inap('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.SP_RPT_RL_3_2_KUNJUNGAN_RAWAT_DARURAT(p_dateStart varchar, p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.SP_RPT_RL_3_2_KUNJUNGAN_RAWAT_DARURAT(p_dateStart varchar, p_dateEnd varchar)
-- RETURNS table(
-- 	medunit_cd Varchar(20),
-- 	medunit_nm Varchar(100),
-- 	Total_Pasien_Rujukan bigint,
-- 	Total_Pasien_Non_Rujukan bigint,
-- 	Dirawat bigint,
-- 	Dirujuk bigint,
-- 	Pulang bigint,
-- 	Mati_Di_IGD bigint,
-- 	DOA bigint
-- )
-- AS $$
-- BEGIN
-- 	RETURN QUERY SELECT 
-- 	B.medunit_cd, 
-- 	B.medunit_nm,
-- 		(SELECT COUNT(medical_cd) 
-- 			FROM trx_medical Y 
-- 			WHERE Y.datetime_in >= p_dateStart::timestamp AND Y.datetime_in <= p_dateEnd::timestamp
-- 			AND Y.medunit_cd=B.medunit_cd 
-- 			AND Y.reff_tp IS NOT NULL 
-- 			AND Y.referensi_cd IS NOT NULL) as Total_Pasien_Rujukan,
-- 		(SELECT COUNT(medical_cd) 
-- 			FROM trx_medical Y 
-- 			WHERE Y.datetime_in >= p_dateStart::timestamp AND Y.datetime_in <= p_dateEnd::timestamp
-- 			AND Y.medunit_cd=B.medunit_cd 
-- 			AND Y.reff_tp IS NULL 
-- 			AND Y.referensi_cd IS NULL) as Total_Pasien_Non_Rujukan,	
-- 		(SELECT COUNT(medical_cd) 
-- 			FROM trx_medical Y 
-- 			WHERE Y.datetime_in >= p_dateStart::timestamp AND Y.datetime_in <= p_dateEnd::timestamp
-- 			AND Y.medunit_cd=B.medunit_cd 
-- 			AND Y.out_tp ='OUT_TP_01') as Dirawat,
-- 		(SELECT COUNT(medical_cd) 
-- 			FROM trx_medical Y 
-- 			WHERE Y.datetime_in >= p_dateStart::timestamp AND Y.datetime_in <= p_dateEnd::timestamp 
-- 			AND Y.medunit_cd=B.medunit_cd 
-- 			AND Y.out_tp ='OUT_TP_02') as Dirujuk,
-- 		(SELECT COUNT(medical_cd) 
-- 			FROM trx_medical Y 
-- 			WHERE Y.datetime_in >= p_dateStart::timestamp AND Y.datetime_in <= p_dateEnd::timestamp
-- 			AND Y.medunit_cd=B.medunit_cd 
-- 			AND Y.out_tp ='OUT_TP_03') as Pulang,
-- 		(SELECT COUNT(medical_cd) 
-- 			FROM trx_medical Y 
-- 			WHERE Y.datetime_in >= p_dateStart::timestamp AND Y.datetime_in <= p_dateEnd::timestamp
-- 			AND Y.medunit_cd=B.medunit_cd 
-- 			AND Y.out_tp ='OUT_TP_04') as Mati_Di_IGD,
-- 		(SELECT COUNT(medical_cd) 
-- 			FROM trx_medical Y 
-- 			WHERE Y.datetime_in >= p_dateStart::timestamp AND Y.datetime_in <= p_dateEnd::timestamp
-- 			AND Y.medunit_cd=B.medunit_cd 
-- 			AND Y.out_tp ='OUT_TP_05') as DOA
-- 	FROM trx_unit_medis B 
-- 	WHERE B.medunit_cd = 'POLISPB'
-- 	OR B.medunit_cd = 'POLISPOG'
-- 	OR B.medunit_cd = 'POLISPA'
-- 	OR B.medunit_cd = 'POLISPJW'
-- 	OR B.medunit_cd = 'POLIUGD';
-- END;
-- $$ 
-- LANGUAGE plpgsql;

-- SELECT * from public.SP_RPT_RL_3_2_KUNJUNGAN_RAWAT_DARURAT('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.SP_RPT_RL_3_3_KEGIATAN_KESEHATAN_GIGI_MULUT (p_dateStart varchar, p_dateEnd varchar); 
-- CREATE OR REPLACE FUNCTION public.SP_RPT_RL_3_3_KEGIATAN_KESEHATAN_GIGI_MULUT (p_dateStart varchar, p_dateEnd varchar) 
-- RETURNS table(
-- 	Jenis_Kegiatan text,
-- 	Jumlah bigint
-- 	)
-- AS 
-- $$
-- BEGIN
-- 	RETURN QUERY SELECT 
-- 	RTRIM(LTRIM(C.treatment_nm)) AS Jenis_Kegiatan,
-- 	COUNT(1) AS Jumlah
-- 	FROM trx_medical_tindakan A
-- 	JOIN trx_medical B ON A.medical_cd = B.medical_cd
-- 	JOIN trx_tindakan C ON A.treatment_cd = C.treatment_cd
-- 	WHERE
-- 		B.medunit_cd = 'POLIGIGI'
-- 	AND B.datetime_in>=  p_dateStart::timestamp
-- 	AND B.datetime_in <=  p_dateEnd::timestamp
-- 	GROUP BY
-- 		C.treatment_nm;
-- END;
-- $$ 
-- LANGUAGE plpgsql;

-- SELECT * from public.SP_RPT_RL_3_3_KEGIATAN_KESEHATAN_GIGI_MULUT('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.SP_RPT_RL_3_4_KEGIATAN_KEBIDANAN (p_dateStart varchar, p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.SP_RPT_RL_3_4_KEGIATAN_KEBIDANAN (p_dateStart varchar, p_dateEnd varchar) 
-- RETURNS table(
-- 	medical_note Varchar(100),
-- 	R_Med_Rumah_Sakit bigint,
-- 	R_Med_Bidan bigint,
-- 	R_Med_Puskesmas bigint,
-- 	R_Faskes_Lain bigint,
-- 	R_Med_Jumlah_Hidup bigint,
-- 	R_Med_Jumlah_Mati bigint,
-- 	R_Med_Jumlah_Total bigint,
-- 	R_NonMed_Jumlah_Hidup bigint,
-- 	R_NonMed_Jumlah_Mati bigint,
-- 	R_NonMed_Jumlah_Total bigint,
-- 	Non_R_Jumlah_Hidup bigint,
-- 	Non_R_Jumlah_Mati bigint,
-- 	Non_R_Jumlah_Total bigint,
-- 	Dirujuk bigint
-- )
-- AS $$
-- BEGIN
-- 	RETURN QUERY SELECT  A.medical_note,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.reff_tp = 'REFF_TP_07') as R_Med_Rumah_Sakit,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.reff_tp = 'REFF_TP_03') as R_Med_Bidan,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.reff_tp = 'REFF_TP_05') as R_Med_Puskesmas,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND (Y.reff_tp = 'REFF_TP_01' OR Y.reff_tp = 'REFF_TP_02' OR Y.reff_tp = 'REFF_TP_06') ) as R_Faskes_Lain,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.out_tp ='OUT_TP_01'
-- 	AND (Y.reff_tp = 'REFF_TP_01' OR Y.reff_tp = 'REFF_TP_02' OR Y.reff_tp = 'REFF_TP_03' OR Y.reff_tp = 'REFF_TP_05' OR Y.reff_tp = 'REFF_TP_06' OR Y.reff_tp = 'REFF_TP_07') ) as R_Med_Jumlah_Hidup,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.out_tp ='OUT_TP_04'
-- 	AND (Y.reff_tp = 'REFF_TP_01' OR Y.reff_tp = 'REFF_TP_02' OR Y.reff_tp = 'REFF_TP_03' OR Y.reff_tp = 'REFF_TP_05' OR Y.reff_tp = 'REFF_TP_06' OR Y.reff_tp = 'REFF_TP_07') ) as R_Med_Jumlah_Mati,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note 
-- 	AND (Y.reff_tp = 'REFF_TP_01' OR Y.reff_tp = 'REFF_TP_02' OR Y.reff_tp = 'REFF_TP_03' OR Y.reff_tp = 'REFF_TP_05' OR Y.reff_tp = 'REFF_TP_06' OR Y.reff_tp = 'REFF_TP_07') ) as R_Med_Jumlah_Total,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.out_tp ='OUT_TP_01' AND (Y.reff_tp = 'REFF_TP_00' OR Y.reff_tp = 'REFF_TP_04') ) as R_NonMed_Jumlah_Hidup,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.out_tp ='OUT_TP_04' AND (Y.reff_tp = 'REFF_TP_00' OR Y.reff_tp = 'REFF_TP_04') ) as R_NonMed_Jumlah_Mati,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND (Y.reff_tp = 'REFF_TP_00' OR Y.reff_tp = 'REFF_TP_04') ) as R_NonMed_Jumlah_Total,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.out_tp ='OUT_TP_01' AND Y.reff_tp IS NULL AND Y.referensi_cd IS NULL) as Non_R_Jumlah_Hidup,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.out_tp ='OUT_TP_04' AND Y.reff_tp IS NULL AND Y.referensi_cd IS NULL) as Non_R_Jumlah_Mati,
-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.reff_tp IS NULL AND Y.referensi_cd IS NULL) as Non_R_Jumlah_Total,

-- 	(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.out_tp ='OUT_TP_02') as Dirujuk
-- 	FROM trx_medical_tindakan  A JOIN trx_medical B ON A.medical_cd =B.medical_cd 
-- 	WHERE B.medunit_cd = 'POLISPOG' 
-- 	AND B.datetime_in >= p_dateStart::timestamp AND B.datetime_in <= p_dateEnd::timestamp 
-- 	GROUP BY A.medical_note;
-- END;
-- $$ 
-- LANGUAGE plpgsql;
-- SELECT * from public.SP_RPT_RL_3_4_KEGIATAN_KEBIDANAN ('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.SP_RPT_RL_3_5_KEGIATAN_PERINATOLOGI (p_dateStart varchar, p_dateEnd varchar));
-- CREATE OR REPLACE FUNCTION public.SP_RPT_RL_3_5_KEGIATAN_PERINATOLOGI (p_dateStart varchar, p_dateEnd varchar))
-- RETURNS table(
-- 	medical_note Varchar(100),
-- 	R_Med_Rumah_Sakit bigint,
-- 	R_Med_Bidan bigint,
-- 	R_Med_Puskesmas bigint,
-- 	R_Faskes_Lain bigint,
-- 	R_Med_Jumlah_Mati bigint,
-- 	R_Med_Jumlah_Total bigint,
-- 	R_NonMed_Jumlah_Mati bigint,
-- 	R_NonMed_Jumlah_Total bigint,
-- 	Non_R_Jumlah_Mati bigint,
-- 	Non_R_Jumlah_Total bigint,
-- 	Dirujuk bigint
-- )
-- AS $$
-- BEGIN
-- 	RETURN QUERY SELECT  A.medical_note,
-- 		(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.reff_tp = 'REFF_TP_07') as R_Med_Rumah_Sakit,
-- 		(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.reff_tp = 'REFF_TP_03') as R_Med_Bidan,
-- 		(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.reff_tp = 'REFF_TP_05') as R_Med_Puskesmas,
-- 		(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND (Y.reff_tp = 'REFF_TP_01' OR Y.reff_tp = 'REFF_TP_02' OR Y.reff_tp = 'REFF_TP_06') ) as R_Faskes_Lain,

-- 		(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.out_tp ='OUT_TP_04'
-- 		AND (Y.reff_tp = 'REFF_TP_01' OR Y.reff_tp = 'REFF_TP_02' OR Y.reff_tp = 'REFF_TP_03' OR Y.reff_tp = 'REFF_TP_05' OR Y.reff_tp = 'REFF_TP_06' OR Y.reff_tp = 'REFF_TP_07') ) as R_Med_Jumlah_Mati,
-- 		(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note 
-- 		AND (Y.reff_tp = 'REFF_TP_01' OR Y.reff_tp = 'REFF_TP_02' OR Y.reff_tp = 'REFF_TP_03' OR Y.reff_tp = 'REFF_TP_05' OR Y.reff_tp = 'REFF_TP_06' OR Y.reff_tp = 'REFF_TP_07') ) as R_Med_Jumlah_Total,

-- 		(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.out_tp ='OUT_TP_04' AND (Y.reff_tp = 'REFF_TP_00' OR Y.reff_tp = 'REFF_TP_04') ) as R_NonMed_Jumlah_Mati,
-- 		(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND (Y.reff_tp = 'REFF_TP_00' OR Y.reff_tp = 'REFF_TP_04') ) as R_NonMed_Jumlah_Total,

-- 		(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.out_tp ='OUT_TP_04' AND Y.reff_tp IS NULL AND Y.referensi_cd IS NULL) as Non_R_Jumlah_Mati,
-- 		(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.reff_tp IS NULL AND Y.referensi_cd IS NULL) as Non_R_Jumlah_Total,

-- 		(SELECT COUNT(x.medical_note) FROM trx_medical_tindakan X JOIN trx_medical Y ON X.medical_cd =Y.medical_cd  WHERE x.medical_note = A.medical_note AND Y.out_tp ='OUT_TP_02') as Dirujuk
-- 	FROM trx_medical_tindakan  A JOIN trx_medical B ON A.medical_cd =B.medical_cd 
-- 	WHERE B.medunit_cd = 'POLITK' 
-- 	AND B.datetime_in >= p_dateStart::timestamp AND B.datetime_in <= p_dateEnd::timestamp 
-- 	GROUP BY A.medical_note;
-- END;
-- $$ 
-- LANGUAGE plpgsql;

-- SELECT * from public.SP_RPT_RL_3_5_KEGIATAN_PERINATOLOGI('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.SP_RPT_RL_3_6_KEGIATAN_PEMBEDAHAN (p_dateStart varchar,p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.SP_RPT_RL_3_6_KEGIATAN_PEMBEDAHAN (p_dateStart varchar,p_dateEnd varchar) 
-- RETURNS table(
-- 	Jenis_Kegiatan text,
-- 	Jumlah bigint
-- 	)
-- AS $$
-- BEGIN
-- 	RETURN QUERY SELECT
-- 		RTRIM(LTRIM(C.treatment_nm)) AS Jenis_Kegiatan,
-- 		COUNT(1)AS Jumlah
-- 	FROM trx_medical_tindakan A
-- 	JOIN trx_medical B ON A.medical_cd = B.medical_cd
-- 	JOIN trx_tindakan C ON A.treatment_cd = C.treatment_cd
-- 	WHERE
-- 		B.medunit_cd = 'POLISPB'
-- 	AND B.datetime_in >=  p_dateStart::timestamp
-- 	AND B.datetime_in <=  p_dateEnd::timestamp
-- 	GROUP BY
-- 		C.treatment_nm;
-- END;
-- $$ 
-- LANGUAGE plpgsql;

-- SELECT * from public.SP_RPT_RL_3_6_KEGIATAN_PEMBEDAHAN('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.SP_RPT_RL_3_7_KEGIATAN_RADIOLOGI (p_dateStart varchar,p_dateEnd varchar) ;
-- CREATE OR REPLACE FUNCTION public.SP_RPT_RL_3_7_KEGIATAN_RADIOLOGI (p_dateStart varchar,p_dateEnd varchar) 
-- RETURNS table(
-- 	Jenis_Kegiatan varchar(100),
-- 	Jumlah bigint
-- 	)
-- AS $$
-- BEGIN
-- 	RETURN QUERY SELECT
-- 		medicalunit_nm AS Jenis_Kegiatan,
-- 		COUNT(1)AS Jumlah
-- 	FROM
-- 		trx_medical_unit mast
-- 	JOIN trx_unitmedis_item a ON a.medicalunit_cd = mast.medicalunit_cd
-- 	AND a.medunit_cd = 'RADIO00'
-- 	AND mast.datetime_trx >=  p_dateStart::timestamp
-- 	AND mast.datetime_trx <=  p_dateEnd::timestamp
-- 	GROUP BY
-- 		medicalunit_nm;
-- END;
-- $$ LANGUAGE plpgsql;

-- SELECT * from public.SP_RPT_RL_3_7_KEGIATAN_RADIOLOGI('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.SP_RPT_RL_3_8_PEMERIKSAAN_LABORATORIUM (p_dateStart varchar,p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.SP_RPT_RL_3_8_PEMERIKSAAN_LABORATORIUM (p_dateStart varchar,p_dateEnd varchar)
-- RETURNS table(
-- 	Jenis_Kegiatan varchar(100),
-- 	Jumlah bigint
-- 	)
-- AS $$
-- BEGIN
-- 	RETURN QUERY SELECT
-- 		medicalunit_nm AS Jenis_Kegiatan,
-- 		COUNT(1)AS Jumlah
-- 	FROM
-- 		trx_medical_unit mast
-- 	JOIN trx_unitmedis_item a ON a.medicalunit_cd = mast.medicalunit_cd
-- 	AND a.medunit_cd = 'LAB00'
-- 	AND mast.datetime_trx >=  p_dateStart::timestamp
-- 	AND mast.datetime_trx <=  p_dateEnd::timestamp
-- 	GROUP BY
-- 		medicalunit_nm;
-- END;
-- $$ LANGUAGE plpgsql;

-- SELECT * from public.SP_RPT_RL_3_8_PEMERIKSAAN_LABORATORIUM('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.sp_rpt_rl_3_9_pelayanan_rehabilitasi_medik(p_dateStart varchar, p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.sp_rpt_rl_3_9_pelayanan_rehabilitasi_medik(p_dateStart varchar, p_dateEnd varchar)
--  RETURNS TABLE(jenis_kegiatan text, jumlah bigint)
-- AS $function$
-- BEGIN
-- 	return query SELECT  RTRIM(LTRIM(A.medical_note)) as Jenis_Kegiatan,COUNT(A.medical_note) AS Jumlah
-- 	FROM public.trx_medical_tindakan A JOIN public.trx_medical B ON A.medical_cd = B.medical_cd
-- 	WHERE B.medunit_cd = 'POLIREHAB' 
-- 	AND B.datetime_in >= p_dateStart::timestamp
-- 	AND B.datetime_in <= p_dateEnd::timestamp
-- 	GROUP BY A.medical_note;
-- END;
-- $function$
-- LANGUAGE plpgsql;

-- SELECT * from public.sp_rpt_rl_3_9_pelayanan_rehabilitasi_medik('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.sp_rpt_rl_3_10_kegiatan_pelayanan_khusus(p_dateStart varchar, p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.sp_rpt_rl_3_10_kegiatan_pelayanan_khusus(p_dateStart varchar, p_dateEnd varchar)
--  RETURNS TABLE(jenis_kegiatan text, jumlah bigint)
-- AS $function$
-- BEGIN
-- 	return Query SELECT 
-- 	RTRIM(LTRIM(A.medical_note)) as Jenis_Kegiatan,
-- 	COUNT(A.medical_note) AS Jumlah
-- 	FROM trx_medical_tindakan A 
-- 	JOIN trx_medical B ON A.medical_cd = B.medical_cd
-- 	WHERE  B.datetime_in >= p_dateStart::timestamp
-- 	AND B.datetime_in <= p_dateEnd::timestamp
-- 	OR A.medical_note LIKE '%elektro%'
-- 	OR A.medical_note LIKE '%kardiographi%'
-- 	OR A.medical_note LIKE '%myographi%' 
-- 	OR A.medical_note LIKE '%echo%'
-- 	OR A.medical_note LIKE '%cardiographi%'
-- 	OR A.medical_note LIKE '%endoskopi%'
-- 	OR A.medical_note LIKE '%hemodialisa%'
-- 	OR A.medical_note LIKE '%densometri%'
-- 	OR A.medical_note LIKE '%tulang%'
-- 	OR A.medical_note LIKE '%densometri tulang%'
-- 	OR A.medical_note LIKE '%pungsi%'
-- 	OR A.medical_note LIKE '%spirometri%'
-- 	OR A.medical_note LIKE '%kulit%'
-- 	OR A.medical_note LIKE '%alergi%'
-- 	OR A.medical_note LIKE '%histamin%'
-- 	OR A.medical_note LIKE '%topometri%'
-- 	OR A.medical_note LIKE '%akupuntur%'
-- 	OR A.medical_note LIKE '%hiperbarik%'
-- 	OR A.medical_note LIKE '%herbal%'
-- 	OR A.medical_note LIKE '%jamu%'
-- 	GROUP BY A.medical_note;
-- END;
-- $function$
-- LANGUAGE plpgsql;

-- SELECT * from public.sp_rpt_rl_3_10_kegiatan_pelayanan_khusus('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.sp_rpt_rl_3_11_kegiatan_kesehatan_jiwa(p_dateStart varchar, p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.sp_rpt_rl_3_11_kegiatan_kesehatan_jiwa(p_dateStart varchar, p_dateEnd varchar)
--  RETURNS TABLE(jenis_kegiatan text, jumlah bigint)
-- AS $function$
-- BEGIN
-- 	return QUERY SELECT  
-- 	RTRIM(LTRIM(A.medical_note)) as Jenis_Kegiatan,
-- 	COUNT(A.medical_note) AS Jumlah
-- 	FROM public.trx_medical_tindakan A JOIN public.trx_medical B ON A.medical_cd = B.medical_cd
-- 	WHERE B.medunit_cd = 'POLISPJW' 
-- 	AND B.datetime_in >= p_dateStart::timestamp AND B.datetime_in <= p_dateEnd::timestamp 
-- 	GROUP BY A.medical_note;
-- END;
-- $function$
-- LANGUAGE plpgsql;

-- SELECT * from public.sp_rpt_rl_3_11_kegiatan_kesehatan_jiwa('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.SP_RPT_RL_3_14_KEGIATAN_RUJUKAN (p_dateStart varchar, p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.SP_RPT_RL_3_14_KEGIATAN_RUJUKAN (p_dateStart varchar, p_dateEnd varchar)
-- RETURNS table(
-- 	medunit_cd varchar(20),
-- 	medunit_nm varchar(100),
-- 	Diterima_Dari_Puskesmas bigint,
-- 	Diterima_Dari_FasKes_Lain bigint,
-- 	Diterima_Dari_RS_Lain bigint,
-- 	Dikembalikan_Ke_Puskesmas bigint,
-- 	Dikembalikan_Ke_FasKes_Lain bigint,
-- 	Dikembalikan_Ke_RS_Lain bigint,
-- 	Dirujuk bigint
-- )
-- AS $$
-- BEGIN
-- 	RETURN Query SELECT 
-- 	U.medunit_cd, 
-- 	U.medunit_nm,
-- 		(SELECT COUNT(X.medical_cd) 
-- 			FROM public.trx_medical X 
-- 			WHERE X.medunit_cd=U.medunit_cd 
-- 			AND X.reff_tp = 'REFF_TP_05' 
-- 			AND X.out_tp='OUT_TP_07' 
-- 			AND X.datetime_in >= p_dateStart::timestamp
-- 			AND X.datetime_in <= p_dateEnd::timestamp
-- 			) as Diterima_Dari_Puskesmas,
-- 		(SELECT COUNT(X.medical_cd) 
-- 			FROM public.trx_medical X 
-- 			WHERE X.medunit_cd=U.medunit_cd 
-- 			AND (X.reff_tp = 'REFF_TP_01' 
-- 			OR X.reff_tp = 'REFF_TP_02' 
-- 			OR X.reff_tp = 'REFF_TP_07') 
-- 			AND X.out_tp='OUT_TP_06' 
-- 			AND X.datetime_in >= p_dateStart::timestamp
-- 			AND X.datetime_in <= p_dateEnd::timestamp
-- 			) as Diterima_Dari_FasKes_Lain,
-- 		(SELECT COUNT(X.medical_cd) 
-- 			FROM public.trx_medical X 
-- 			WHERE X.medunit_cd=U.medunit_cd 
-- 			AND X.reff_tp = 'REFF_TP_07' 
-- 			AND X.out_tp='OUT_TP_07' 
-- 			AND X.datetime_in >= p_dateStart::timestamp
-- 			AND X.datetime_in <= p_dateEnd::timestamp
-- 			) as Diterima_Dari_RS_Lain,
-- 		(SELECT COUNT(X.medical_cd) 
-- 			FROM public.trx_medical X 
-- 			WHERE X.medunit_cd=U.medunit_cd 
-- 			AND X.reff_tp = 'REFF_TP_05' 
-- 			AND X.out_tp='OUT_TP_06' 
-- 			AND X.datetime_in >= p_dateStart::timestamp
-- 			AND X.datetime_in <= p_dateEnd::timestamp
-- 			) as Dikembalikan_Ke_Puskesmas,
-- 		(SELECT COUNT(X.medical_cd) 
-- 			FROM public.trx_medical X 
-- 			WHERE X.medunit_cd=U.medunit_cd 
-- 			AND (X.reff_tp = 'REFF_TP_01' 
-- 			OR X.reff_tp = 'REFF_TP_02' 
-- 			OR X.reff_tp = 'REFF_TP_06' 
-- 			AND X.datetime_in >= p_dateStart::timestamp
-- 			AND X.datetime_in <= p_dateEnd::timestamp
-- 			AND X.out_tp='OUT_TP_06')) as Dikembalikan_Ke_FasKes_Lain,
-- 		(SELECT COUNT(X.medical_cd) 
-- 			FROM public.trx_medical X 
-- 			WHERE X.medunit_cd=U.medunit_cd 
-- 			AND X.reff_tp = 'REFF_TP_07' 
-- 			AND X.out_tp='OUT_TP_06' 
-- 			AND X.datetime_in >= p_dateStart::timestamp
-- 			AND X.datetime_in <= p_dateEnd::timestamp
-- 			) as Dikembalikan_Ke_RS_Lain,
-- 		(SELECT COUNT(X.medical_cd) 
-- 			FROM public.trx_medical X 
-- 			WHERE X.medunit_cd=U.medunit_cd 
-- 			AND X.out_tp ='OUT_TP_02' 
-- 			AND X.datetime_in >= p_dateStart::timestamp
-- 			AND X.datetime_in <= p_dateEnd::timestamp
-- 			) as Dirujuk
-- 	FROM public.trx_unit_medis U;  
-- END;
-- $$ LANGUAGE plpgsql;

-- SELECT * from public.SP_RPT_RL_3_14_KEGIATAN_RUJUKAN('2017-01-01', '2017-12-31');


-- DROP FUNCTION public.SP_RPT_RL_3_15_CARA_BAYAR (p_dateStart varchar, p_dateEnd varchar);
-- CREATE OR REPLACE FUNCTION public.SP_RPT_RL_3_15_CARA_BAYAR (p_dateStart varchar, p_dateEnd varchar)
-- RETURNS table(
-- 	code_nm varchar(100),
-- 	RI_PasienKeluar bigint,
-- 	RI_LamDirawat bigint,
-- 	RawatInap bigint,
-- 	RawatJalan bigint,
-- 	RJ_Laboratorium bigint,
-- 	RJ_Radiologi bigint,
-- 	RJ_Lain bigint
-- )
-- AS $$
-- BEGIN
-- 	RETURN QUERY SELECT COM.code_nm,
-- 		(SELECT COUNT(med.pasien_cd) 
-- 			FROM public.trx_medical med 
-- 			JOIN public.trx_settlement sett ON med.pasien_cd=sett.pasien_cd
-- 			WHERE sett.payment_tp=COM.com_cd 
-- 			AND med.medical_tp='MEDICAL_TP_02' 
-- 			AND med.out_tp IS NOT NULL 
-- 			AND MED.datetime_in >=  p_dateStart::timestamp
-- 			AND MED.datetime_in <= p_dateEnd::timestamp
-- 			) as RI_PasienKeluar,
-- 		(SELECT COUNT(med.pasien_cd) 
-- 			FROM public.trx_medical med 
-- 			JOIN public.trx_settlement sett ON med.pasien_cd=sett.pasien_cd
-- 			WHERE sett.payment_tp=COM.com_cd 
-- 			AND med.medical_tp='MEDICAL_TP_02' 
-- 			AND med.out_tp IS NULL 
-- 			AND MED.datetime_in >=  p_dateStart::timestamp
-- 			AND MED.datetime_in <= p_dateEnd::timestamp
-- 			) as RI_LamDirawat,
-- 		(SELECT COUNT(med.pasien_cd) 
-- 			FROM public.trx_medical med 
-- 			JOIN public.trx_settlement sett ON med.pasien_cd=sett.pasien_cd
-- 			WHERE sett.payment_tp=COM.com_cd 
-- 			AND med.medical_tp='MEDICAL_TP_02' 
-- 			AND MED.datetime_in >=  p_dateStart::timestamp
-- 			AND MED.datetime_in <= p_dateEnd::timestamp
-- 			) as RawatInap,
-- 		(SELECT COUNT(med.pasien_cd) 
-- 			FROM public.trx_medical med 
-- 			JOIN public.trx_settlement sett ON med.pasien_cd=sett.pasien_cd
-- 			WHERE sett.payment_tp=COM.com_cd 
-- 			AND med.medical_tp='MEDICAL_TP_01' 
-- 			AND MED.datetime_in >=  p_dateStart::timestamp
-- 			AND MED.datetime_in <= p_dateEnd::timestamp
-- 			) as RawatJalan,
-- 		(SELECT COUNT(med.pasien_cd) 
-- 			FROM public.trx_medical med 
-- 			JOIN public.trx_settlement sett ON med.pasien_cd=sett.pasien_cd
-- 			JOIN public.trx_unit_medis um ON med.medunit_cd=um.medunit_cd
-- 			WHERE sett.payment_tp=COM.com_cd 
-- 			AND med.medical_tp='MEDICAL_TP_01' 
-- 			AND um.medicalunit_tp='MEDICALUNIT_TP_2' 
-- 			AND MED.datetime_in >=  p_dateStart::timestamp
-- 			AND MED.datetime_in <= p_dateEnd::timestamp
-- 			) as RJ_Laboratorium,
-- 		(SELECT COUNT(med.pasien_cd) 
-- 			FROM public.trx_medical med 
-- 			JOIN public.trx_settlement sett ON med.pasien_cd=sett.pasien_cd
-- 			JOIN public.trx_unit_medis um ON med.medunit_cd=um.medunit_cd
-- 			WHERE sett.payment_tp=COM.com_cd 
-- 			AND med.medical_tp='MEDICAL_TP_01' 
-- 			AND um.medicalunit_tp='MEDICALUNIT_TP_3' 
-- 			AND MED.datetime_in >=  p_dateStart::timestamp
-- 			AND MED.datetime_in <= p_dateEnd::timestamp
-- 			) as RJ_Radiologi,
-- 		(SELECT COUNT(med.pasien_cd) 
-- 			FROM public.trx_medical med 
-- 			JOIN public.trx_settlement sett ON med.pasien_cd=sett.pasien_cd
-- 			JOIN public.trx_unit_medis um ON med.medunit_cd=um.medunit_cd
-- 			WHERE sett.payment_tp=COM.com_cd 
-- 			AND med.medical_tp='MEDICAL_TP_01' 
-- 			AND um.medicalunit_tp='MEDICALUNIT_TP_1' 
-- 			AND MED.datetime_in >=  p_dateStart::timestamp
-- 			AND MED.datetime_in <= p_dateEnd::timestamp
-- 			) as RJ_Lain 
-- 	FROM public.com_code COM
-- 	WHERE COM.code_group='PAYMENT_TP';
-- END;
-- $$ LANGUAGE plpgsql;

-- SELECT * from public.SP_RPT_RL_3_15_CARA_BAYAR('2017-01-01', '2017-12-31');

-- DROP FUNCTION public.SP_RPT_RL_4_A_PENYAKIT_RAWAT_INAP (p_pdtDateStart timestamp,p_pdtDateEnd timestamp);
-- CREATE OR REPLACE FUNCTION public.SP_RPT_RL_4_A_PENYAKIT_RAWAT_INAP (p_pdtDateStart timestamp,p_pdtDateEnd timestamp)
-- RETURNS table(
-- 	icd_cd Varchar(20),
-- 	icd_nm Varchar(100),
-- 	laki_0To6hari bigint,
-- 	perempuan_0To6hari bigint,
-- 	laki_7To28hari bigint,
-- 	perempuan_7To28hari bigint,
-- 	laki_28hariTo1th bigint,
-- 	perempuan_28hariTo1th bigint,
-- 	laki_1To4th bigint,
-- 	perempuan_1To4th bigint,
-- 	laki_5To14th bigint,
-- 	perempuan_5To14th bigint,
-- 	laki_15To24th bigint,
-- 	perempuan_15To24th bigint,
-- 	laki_25To44th bigint,
-- 	perempuan_25To44th bigint,
-- 	laki_45To64th bigint,
-- 	perempuan_45To64th bigint,
-- 	laki_lebih65th bigint,
-- 	perempuan_lebih65th bigint,
-- 	kosong bigint,
-- 	total_laki bigint,
-- 	total_perempuan bigint,
-- 	total_hidup bigint,
-- 	total_mati bigint,
-- 	total bigint
-- )
-- AS $$
-- BEGIN
-- 	RETURN QUERY SELECT ICD.icd_cd,ICD.icd_nm,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= 0 AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= 6 ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= 0 AND Pas2.age <= 6)
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_01'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as laki_0To6hari,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= 0 AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= 6 ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= 0 AND Pas2.age <= 6)
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_02'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as perempuan_0To6hari,	
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= 7 AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= 28 ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= 7 AND Pas2.age <= 28)
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_01'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as laki_7To28hari,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= 7 AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= 28 ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= 7 AND Pas2.age <= 28)
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_02'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as perempuan_7To28hari,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= 28 AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) < 365 ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= 28 AND Pas2.age < 365)
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_01'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as laki_28hariTo1th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= 28 AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) < 365 ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= 28 AND Pas2.age < 365)
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_02'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as perempuan_28hariTo1th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= 365 AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= (4*365) ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= 365 AND Pas2.age <= (4*365))
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_01'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as laki_1To4th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= 365 AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= (4*365) ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= 365 AND Pas2.age <= (4*365))
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_02'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as perempuan_1To4th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= (5*365) AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= (14*365) ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= (5*365) AND Pas2.age <= (14*365))
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_01'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as laki_5To14th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= (5*365) AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= (14*365) ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= (5*365) AND Pas2.age <= (14*365))
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_02'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as perempuan_5To14th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= (15*365) AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= (24*365) ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= (15*365) AND Pas2.age <= (24*365))
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_01'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as laki_15To24th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= (15*365) AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= (24*365) ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= (15*365) AND Pas2.age <= (24*365))
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_02'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as perempuan_15To24th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= (25*365) AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= (44*365) ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= (25*365) AND Pas2.age <= (44*365))
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_01'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as laki_25To44th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= (25*365) AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= (44*365) ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= (25*365) AND Pas2.age <= (44*365))
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_02'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as perempuan_25To44th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= (45*365) AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= (64*365) ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= (45*365) AND Pas2.age <= (64*365))
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_01'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as laki_45To64th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= (45*365) AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) <= (64*365) ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= (45*365) AND Pas2.age <= (64*365))
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_02'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as perempuan_45To64th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= (65*365)  ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= (65*365) )
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_01'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as laki_lebih65th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE (
-- 								(PAS2.birth_date IS NOT NULL AND public.fn_datediff_day(Pas2.birth_date::varchar, now()::varchar) >= (65*365)  ) OR
-- 								(PAS2.birth_date IS NULL AND Pas2.age >= (65*365) )
-- 							)
-- 					AND Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND Pas2.gender_tp='GENDER_TP_02'
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as perempuan_lebih65th,
-- 				(SELECT COUNT(MR2.medical_record_seqno)
-- 					FROM trx_medical_record MR2
-- 					LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 					LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 					--LEFT JOIN simrke.VW_TRX_ICD_MOBIRDITAS VW2 ON VW2.icd_cd = MR2.icd_cd
-- 					LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 					WHERE Med2.medical_tp='MEDICAL_TP_02'
-- 					AND Med2.out_tp IS NOT NULL
-- 					AND ICD2.icd_cd = ICD.icd_cd
-- 					AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp
-- 					AND PAS2.birth_date IS NULL AND Pas2.age IS NULL) as kosong,
-- 		(SELECT COUNT(MR2.medical_record_seqno)
-- 			FROM trx_medical_record MR2
-- 			LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd  
-- 			LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 			LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 			WHERE Med2.medical_tp='MEDICAL_TP_02'
-- 			AND Med2.out_tp IS NOT NULL
-- 			AND Pas2.gender_tp='GENDER_TP_01'
-- 			AND ICD2.icd_cd = icd.icd_cd
-- 			AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as total_laki,
-- 		(SELECT COUNT(MR2.medical_record_seqno)
-- 			FROM trx_medical_record MR2 
-- 			LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd 
-- 			LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 			LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 			WHERE Med2.medical_tp='MEDICAL_TP_02'
-- 			AND Med2.out_tp IS NOT NULL
-- 			AND Pas2.gender_tp='GENDER_TP_02'
-- 			AND ICD2.icd_cd = icd.icd_cd
-- 			AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as total_perempuan,
-- 		(SELECT COUNT(MR2.medical_record_seqno)
-- 			FROM trx_medical_record MR2
-- 			LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd 
-- 			LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 			LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 			WHERE Med2.medical_tp='MEDICAL_TP_02'
-- 			AND (Med2.out_tp <> 'OUT_TP_04' AND Med2.out_tp IS NOT NULL)
-- 			AND ICD2.icd_cd = icd.icd_cd
-- 			AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as total_hidup,
-- 		(SELECT COUNT(MR2.medical_record_seqno)
-- 			FROM trx_medical_record MR2
-- 			LEFT JOIN trx_medical Med2 ON Med2.medical_cd = MR2.medical_cd 
-- 			LEFT JOIN trx_pasien Pas2 ON Pas2.pasien_cd = MR2.pasien_cd
-- 			LEFT JOIN trx_icd ICD2 ON ICD2.icd_cd = MR2.icd_cd
-- 			WHERE Med2.medical_tp='MEDICAL_TP_02'
-- 			AND (Med2.out_tp = 'OUT_TP_04' AND Med2.out_tp IS NOT NULL)
-- 			AND ICD2.icd_cd = icd.icd_cd
-- 			AND MR2.datetime_record >=p_dateStart::timestamp AND MR2.datetime_record <= p_dateEnd::timestamp) as total_mati,	
-- COUNT(MR.medical_record_seqno) as total
-- FROM trx_medical_record MR
-- LEFT JOIN trx_medical Med ON Med.medical_cd = MR.medical_cd  
-- LEFT JOIN trx_pasien Pas ON Pas.pasien_cd = MR.pasien_cd
-- LEFT JOIN trx_icd ICD ON ICD.icd_cd = MR.icd_cd
-- WHERE med.medical_tp='MEDICAL_TP_02'
-- AND Med.out_tp IS NOT NULL
-- AND ICD.icd_cd IS NOT NULL
-- AND MR.datetime_record >=p_dateStart::timestamp AND MR.datetime_record <= p_dateEnd::timestamp
-- GROUP BY ICD.icd_cd, ICD.icd_nm
-- ORDER BY ICD.icd_cd;
-- END;
-- $$ 
-- LANGUAGE plpgsql;


-- SELECT * from public.SP_RPT_RL_4_A_PENYAKIT_RAWAT_INAP('2017-01-01', '2017-12-31');

/*new bor*/
SELECT 
bangsal.bangsal_nm,
kelas.kelas_nm,
(select count(*) from trx_ruang where bangsal_cd=bangsal.bangsal_cd and kelas_cd=kelas.kelas_cd) as total_ruang,
COALESCE(public.FN_RPT_TOTAL_PASIENBANGSAL(bangsal.bangsal_cd,kelas.kelas_cd,'2017-03-01'::varchar,'2017-03-31'::varchar),0) AS total_pasien,
COALESCE(public.FN_RPT_TOTAL_HARIRAWAT(ruang.kelas_cd,'2017-03-01','2017-03-31'),0) AS total_harirawat,
to_char('2017-03-31'::timestamp, 'dd')::integer AS day_month
FROM trx_bangsal bangsal
left join trx_ruang ruang ON bangsal.bangsal_cd=ruang.ruang_cd AND COALESCE(ruang.ruang_tp,'')<>'1'
join trx_kelas kelas on 1=1
GROUP BY bangsal.bangsal_cd , ruang.kelas_cd ,kelas.kelas_nm,kelas.kelas_cd
ORDER BY bangsal.bangsal_nm, kelas.kelas_nm;

/*new gdr*/
-- SELECT 
-- bangsal.bangsal_nm,
-- kelas.kelas_nm,
-- (select count(*) from trx_ruang where bangsal_cd=bangsal.bangsal_cd and kelas_cd=kelas.kelas_cd) as total_ruang,
-- COALESCE(public.FN_RPT_TOTAL_PASIENBANGSAL(bangsal.bangsal_cd,kelas.kelas_cd,'2017-03-01'::varchar,'2017-03-31'::varchar),0) AS total_pasien,
-- COALESCE(public.FN_RPT_TOTAL_DEATH(ruang.kelas_cd,'2017-03-01','2017-03-31'),0) AS total_meninggal,
-- to_char('2017-03-31'::timestamp, 'dd')::integer AS day_month
-- FROM trx_bangsal bangsal
-- left join trx_ruang ruang ON bangsal.bangsal_cd=ruang.ruang_cd AND COALESCE(ruang.ruang_tp,'')<>'1'
-- join trx_kelas kelas on 1=1
-- GROUP BY bangsal.bangsal_cd , ruang.kelas_cd ,kelas.kelas_nm,kelas.kelas_cd
-- ORDER BY bangsal.bangsal_nm, kelas.kelas_nm;

/*new ndr*/
-- SELECT 
-- bangsal.bangsal_nm,
-- kelas.kelas_nm,
-- (select count(*) from trx_ruang where bangsal_cd=bangsal.bangsal_cd and kelas_cd=kelas.kelas_cd) as total_ruang,
-- COALESCE(public.FN_RPT_TOTAL_PASIENBANGSAL(bangsal.bangsal_cd,kelas.kelas_cd,'2017-03-01'::varchar,'2017-03-31'::varchar),0) AS total_pasien,
-- COALESCE(public.FN_RPT_TOTAL_DEATH_OUTTP11(ruang.kelas_cd,'2017-03-01','2017-03-31'),0) AS total_meninggal,
-- to_char('2017-03-31'::timestamp, 'dd')::integer AS day_month
-- FROM trx_bangsal bangsal
-- left join trx_ruang ruang ON bangsal.bangsal_cd=ruang.ruang_cd AND COALESCE(ruang.ruang_tp,'')<>'1'
-- join trx_kelas kelas on 1=1
-- GROUP BY bangsal.bangsal_cd , ruang.kelas_cd ,kelas.kelas_nm,kelas.kelas_cd
-- ORDER BY bangsal.bangsal_nm, kelas.kelas_nm;

-- select 
-- icd.icd_cd,
-- icd_nm,
-- count(*) as jumlah
-- from trx_medical_record mr
-- join trx_medical med on med.medical_cd=mr.medical_cd and med.medical_tp='MEDICAL_TP_01' -- rawat jalan
-- left join trx_icd as icd on icd.icd_cd=mr.icd_cd 
-- 	and mr.case_tp='RM_TP_1' 
-- 	and to_char(datetime_record, 'MM')='01' --bulan
-- 	and to_char(datetime_record,'YYYY') ='2017' -- tahun
-- group by icd.icd_cd, icd_nm
-- order by count(*) desc
-- limit 20;